﻿<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>Распространение событий DOM Level 2</title>

    <style>
        .cl1 {
            transform: scale(1);
        }

        .cl2 {
            transform: scale(2);
        }
    </style>

    <script>

        // В модели DOM Level 2 события распространяются по следующему принципу:
        // На этапе ПЕРЕХВАТА событие распространяется от Document вниз до целевого элемента управления.
        // Второй этап - СОБЫТИЕ В ЦЕЛЕВОМ УЗЛЕ.
        // На третьем этапе событие ВСПЛЫВАЕТ от целевого элемента обратно вверх до корневого элемента.

        // последний параметр в методе addEventListener - 
        // true - обработать событие на этапе ПЕРЕХВАТА
        // false - обработать событие на этапе ВСПЛЫВАНИЕ
        
        const isTunnel = true;

        window.onload = function () {
            const e1 = document.getElementById("first");
            const e2 = document.getElementById("second");
            const e3 = document.getElementById("third");

            e1.addEventListener("click",
                function () {
                  
                    this.style.backgroundColor = "green";
                    alert("Обработчик DIV 1");
                
                },
            isTunnel);

            e2.addEventListener("click",
                function () {
                   
                    this.style.backgroundColor = "yellow";
                    alert("Обработчик DIV 2");
                },
            isTunnel);

            e3.addEventListener("click",
                function () {
                    this.style.backgroundColor = "red";
                    alert("Обработчик DIV 3");
                },
            isTunnel);
        }

    </script>

    <style>
        div {
            border: 3px solid gray;
            padding: 50px;
            background-color: white;
        }
    </style>
</head>
<body>
    Первый
    <div id="first">
        Второй
        <div id="second">
            Третий
            <div id="third">
            </div>
        </div>
    </div>
</body>
</html>
